# The LearningOnline Network
# Internal Server Error Handler
#
# $Id: lonerrorhandler.pm,v 1.3 2001/12/19 17:17:46 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer
#
package Apache::lonerrorhandler;

use strict;
use Apache::Constants qw(:common);

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

# ------------------------------------------------------------- Get environment
     my $envkey;
     my $env='';
 
     foreach $envkey (sort keys %ENV) {
 	$env.="$envkey: $ENV{$envkey}\n";
     }

     $env=~s/\"/\'\'/g;
     my $recipients=$r->dir_config('lonAdmEMail').','.
                     $r->dir_config('lonSysEMail'); 

     my $req=$r->as_string();
     $req=~s/\"/\'\'/g;

# --------------------------------------------------- Print login screen header
    $r->print(<<ENDDOCUMENT);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
<body bgcolor="#FFFFFF">
<img src="/adm/lonKaputt/lonlogo_broken.gif" align=left>
<h1>Sorry!</h1>
<h2>Somewhere something went wrong - please help us to find out what.</h2>
Please take a moment to fill out the form below. Your information, together
with internal debugging information, will be emailed to the system and server
administrators.
<form action="mailto:$recipients" method=get enctype="text/plain">
<input type=submit value="Send Information">
<h3>Please describe what you did just before this screen came up</h3>
<input type=hidden name=req value="$req">
<textarea name=prioraction cols=50 rows=5>
</textarea>
<h3>Is this problem reproducible?</h3>
<input type=checkbox name=reproducible value=yes> Yes!
<h3>Do you have any guesses why this might have happened?</h3>
<textarea name=guesses cols=50 rows=5>
</textarea>
<input type=hidden name=environment value="$env"><p>
<input type=submit value="Send Information">
</form>
<h1>Thank you for your help!</h1>
</body>
</html>
ENDDOCUMENT
# -------------------------- Better terminate this in case something was sticky
    $r->child_terminate();

    return OK;
} 

1;
__END__
